"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var find_1 = require("./find");
var update = function (written, completed) {
    return function (prevState, props) {
        if (props.value) {
            return prevState;
        }
        return {
            written: written,
            completed: completed
        };
    };
};
var InputAutocomplete = (function (_super) {
    __extends(InputAutocomplete, _super);
    function InputAutocomplete(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            written: (props.value && String(props.value)) || (props.defaultValue && String(props.defaultValue)) || '',
            completed: '',
        };
        _this.handleOnChange = _this.handleOnChange.bind(_this);
        return _this;
    }
    InputAutocomplete.prototype.fireOnChange = function (ev, changedValue) {
        if (!this.props.onChange) {
            return;
        }
        if (!changedValue) {
            this.props.onChange(ev);
            return;
        }
        var newEvent = __assign({}, ev, { currentTarget: __assign({}, ev.currentTarget, { value: changedValue }) });
        this.props.onChange(newEvent);
    };
    InputAutocomplete.prototype.handleOnChange = function (ev) {
        var target = ev.currentTarget;
        var value = target.value;
        var performMatch = value.length > this.state.written.length;
        if (!performMatch) {
            this.fireOnChange(ev);
            this.setState(update(value, ''));
            return;
        }
        var match = find_1.default(this.props.autocompleteValues, function (autocompleteValue) { return autocompleteValue.indexOf(value) == 0; });
        if (match) {
            this.setState(update(value, match.replace(value, '')), function () {
                target.focus();
                target.setSelectionRange(value.length, match.length);
            });
        }
        else {
            this.setState(update(value, ''));
        }
        this.fireOnChange(ev, match);
    };
    InputAutocomplete.prototype.render = function () {
        var _a = this.props, autocompleteValues = _a.autocompleteValues, props = __rest(_a, ["autocompleteValues"]);
        return React.createElement("input", __assign({}, props, { value: props.value || "" + this.state.written + this.state.completed, onChange: this.handleOnChange }));
    };
    return InputAutocomplete;
}(React.Component));
exports.InputAutocomplete = InputAutocomplete;
exports.default = InputAutocomplete;
//# sourceMappingURL=InputAutocomplete.js.map